/* Thunderbird Equations
  Author: Josh Eads <jmer43@mst.edu>
  Version: 1.2.1 - April 2, 2009
*/

// ====================================================================
//       URLEncode and URLDecode functions
//
// Copyright Albion Research Ltd. 2002
// http://www.albionresearch.com/
//
// You may copy these functions providing that 
// (a) you leave this copyright notice intact, and 
// (b) if you use these functions on a publicly accessible
//     web site you include a credit somewhere on the web site 
//     with a link back to http://www.albionresearch.com/
//
// If you find or fix any bugs, please let us know at albionresearch.com
//
// SpecialThanks to Neelesh Thakur for being the first to
// report a bug in URLDecode() - now fixed 2003-02-19.
// And thanks to everyone else who has provided comments and suggestions.
// ====================================================================


var imageEquations = {
  urlEncode: function (input) {
	// The Javascript escape and unescape functions do not correspond
	// with what browsers actually do...
	var SAFECHARS = "0123456789" +					// Numeric
					"ABCDEFGHIJKLMNOPQRSTUVWXYZ" +	// Alphabetic
					"abcdefghijklmnopqrstuvwxyz" +
					"-_.!~*'()";					// RFC2396 Mark characters
	var HEX = "0123456789ABCDEF";

	var plaintext = input; //document.URLForm.F1.value;
	var encoded = "";
	for (var i = 0; i < plaintext.length; i++ ) {
		var ch = plaintext.charAt(i);
	    if (ch == " ") {
		    encoded += "+";				// x-www-urlencoded, rather than %20
		} else if (SAFECHARS.indexOf(ch) != -1) {
		    encoded += ch;
		} else {
		    var charCode = ch.charCodeAt(0);
			if (charCode > 255) {
			    alert( "Unicode Character '" 
                        + ch 
                        + "' cannot be encoded using standard URL encoding.\n" +
				          "(URL encoding only supports 8-bit characters.)\n" +
						  "A space (+) will be substituted." );
				encoded += "+";
			} else {
				encoded += "%";
				encoded += HEX.charAt((charCode >> 4) & 0xF);
				encoded += HEX.charAt(charCode & 0xF);
			}
		}
	} // for

	//document.URLForm.F2.value = encoded;
    //document.URLForm.F2.select();
	return encoded;
  },
  onLoad: function() {
    // initialization code
    var tabbox = document.getElementById("TabBox");
    var tabs = tabbox.getElementsByTagName("tabs")[0];
    tabs.setAttribute("id", "tabs-list");
    var tabpanels = tabbox.getElementsByTagName("tabpanels")[0];
    tabpanels.setAttribute("id", "tabpanels-list");
    
    var latexRegEx = /\$.*?\$/;
    var latexMatch = document.getElementById("altTextInput").value.search(latexRegEx);
    if(latexMatch == -1)
    {
        document.getElementById("tabpanels-latex").hidden = true;
    }
    else
    {
        var tempStr = String(document.getElementById("altTextInput").value.match(latexRegEx))
        document.getElementById("srcEquation").value = tempStr.substring(1,tempStr.length-1);
    }
  },
  
  refresh: function() {
      var eqn = document.getElementById("srcEquation").value;

	  var size = 0;
      if(document.getElementById("fontSmall").selected == true)
      	size = 0;
	  else if(document.getElementById("fontNormal").selected == true)
		size = 2;
	  else if(document.getElementById("fontLarge").selected == true)
		size = 4;
		
      document.getElementById("srcInput").value = "http://l.wordpress.com/latex.php?latex=" + 
        imageEquations.urlEncode(eqn) + "&bg=ffffff&fg=000000&s=" + size;
      document.getElementById("altTextInput").value = "\$" + eqn + "\$";
      ChangeImageSrc();
  }
};
window.addEventListener("load", function(e) { imageEquations.onLoad(e); }, false);
